-- A small piece of code for managing fading in and out
--
-- Uses the following values from the self object
--
--   visHealth  Health percentage
--   visMana    Mana percentage
--   visAlpha   Disable fading and force alpha to this if present
-----------------------------------------------------------------------------

local function FADE_GetCurrentFade(self, fadeStatus)
   if (not fadeStatus) then fadeStatus = "full" ; end

   local fullMana;
   if (self.visManaMax == 0) then
      fullMana = 1;
   elseif (self.visPowerType == 1) then
      if ((self.visMana or 0) <= (1-self.manaUnfade)) then fullMana = 1; end
   else
      if ((self.visMana or 0) >= self.manaUnfade) then fullMana = 1; end
   end

   if ((self.visHealth == 1) and fullMana) then
      return "full";
   end

   if (fadeStatus == "full") then
      fadeStatus = "normal";
   end

   if (fadeStatus ~= "alert") then
      if ((self.visHealth) and (self.visHealth < self.healthAlert) 
	  and (not self.isTarget)) then
	 fadeStatus = "alert"
      end
   end
   
   return fadeStatus;
end

function StatRingsFadeModel_Update(self, instant)
   if (self.visAlpha) then
      self:FadeSet(self.visAlpha);
      return;
   end
   local oldFade = self.fadeStatus;
   local fade = FADE_GetCurrentFade(self, oldFade);
   if ((fade == oldFade) and (not instant)) then
      return;
   end
   self.fadeStatus = fade;
   if (not oldFade) then
      instant = true;
   end
   local alpha,speed;
   if (fade == "alert") then
      alpha,speed = self.alphaAlert, self.timeAlert;
   elseif (fade == "full") then
      alpha,speed = self.alphaFull, self.timeFull;
   else
      alpha,speed = self.alphaNormal, self.timeNormal;
   end
   if (instant or (speed == 0)) then
      self:FadeSet(alpha);
   else
      self:FadeTo(alpha, speed);
   end
end